; =====================================================;
;                                                      ;
;    hid.inc for Easy Code 2.0 64-bit Masm projects    ;
;                  (version 1.0.0)                     ;
;                                                      ;
;             Copyright  Ramon Sala 2022              ;
;                                                      ;
; =====================================================;

IFNDEF HID_INC
HID_INC   EQU     1

DATA_SIZE_MASK                                  EQU     003H
TYPE_MASK                                       EQU     00CH
TAG_MASK                                        EQU     0F0H

DATA_SIZE_0                                     EQU     000H
DATA_SIZE_1                                     EQU     001H
DATA_SIZE_2                                     EQU     002H
DATA_SIZE_4                                     EQU     003H

TYPE_MAIN                                       EQU     000H
TYPE_GLOBAL                                     EQU     004H
TYPE_LOCAL                                      EQU     008H

TAG_MAIN_INPUT                                  EQU     080H
TAG_MAIN_OUTPUT                                 EQU     090H
TAG_MAIN_COLLECTION                             EQU     0A0H
TAG_MAIN_FEATURE                                EQU     0B0H
TAG_MAIN_ENDCOLLECTION                          EQU     0C0H

TAG_GLOBAL_USAGEPAGE                            EQU     000H
TAG_GLOBAL_LOGICALMIN                           EQU     010H
TAG_GLOBAL_LOGICALMAX                           EQU     020H
TAG_GLOBAL_PHYSMIN                              EQU     030H
TAG_GLOBAL_PHYSMAX                              EQU     040H
TAG_GLOBAL_UNITEXP                              EQU     050H
TAG_GLOBAL_UNIT                                 EQU     060H
TAG_GLOBAL_REPORTSIZE                           EQU     070H
TAG_GLOBAL_REPORTID                             EQU     080H
TAG_GLOBAL_REPORTCOUNT                          EQU     090H
TAG_GLOBAL_PUSH                                 EQU     0A0H
TAG_GLOBAL_POP                                  EQU     0B0H

TAG_LOCAL_USAGE                                 EQU     000H
TAG_LOCAL_USAGEMIN                              EQU     010H
TAG_LOCAL_USAGEMAX                              EQU     020H

HID_GET_REPORT                                  EQU     001H
HID_GET_IDLE                                    EQU     002H
HID_GET_PROTOCOL                                EQU     003H
HID_SET_REPORT                                  EQU     009H
HID_SET_IDLE                                    EQU     00AH
HID_SET_PROTOCOL                                EQU     00BH

HID_HID_DESCRIPTOR_TYPE                         EQU     021H
HID_REPORT_DESCRIPTOR_TYPE                      EQU     022H
HID_PHYSICAL_DESCRIPTOR_TYPE                    EQU     023H

HID_SUBCLASS_NONE                               EQU     0
HID_SUBCLASS_BOOT_INTERFACE                     EQU     1

HID_PROTOCOL_NONE                               EQU     000H
HID_PROTOCOL_KEYBOARD                           EQU     001H
HID_PROTOCOL_MOUSE                              EQU     002H

HID_BOOT_PROTOCOL                               EQU     000H
HID_RPT_PROTOCOL                                EQU     001H

HID_REPORT_TYPE_INPUT                           EQU     1
HID_REPORT_TYPE_OUTPUT                          EQU     2
HID_REPORT_TYPE_FEATURE                         EQU     3

HID_REQUEST_GET_REPORT                          EQU     001H
HID_REQUEST_GET_IDLE                            EQU     002H
HID_REQUEST_GET_PROTOCOL                        EQU     003H
HID_REQUEST_SET_REPORT                          EQU     009H
HID_REQUEST_SET_IDLE                            EQU     00AH
HID_REQUEST_SET_PROTOCOL                        EQU     00BH

HID_DESCRIPTOR_HID                              EQU     021H
HID_DESCRIPTOR_REPORT                           EQU     022H
HID_DESRIPTOR_PHY                               EQU     023H

HID_INTF                                        EQU     003H

HID_BOOT_INTF_SUBCLASS                          EQU     001H


HID_ITEM_TYPE_MAIN                              EQU     0
HID_ITEM_TYPE_GLOBAL                            EQU     1
HID_ITEM_TYPE_LOCAL                             EQU     2
HID_ITEM_TYPE_RESERVED                          EQU     3

HID_LONG_ITEM_PREFIX                            EQU     0FEH

bmHID_MAIN_ITEM_TAG                             EQU     0FCH

bmHID_MAIN_ITEM_INPUT                           EQU     080H
bmHID_MAIN_ITEM_OUTPUT                          EQU     090H
bmHID_MAIN_ITEM_COLLECTION                      EQU     0A0H
bmHID_MAIN_ITEM_FEATURE                         EQU     0B0H
bmHID_MAIN_ITEM_END_COLLECTION                  EQU     0CEH

HID_MAIN_ITEM_COLLECTION_PHYSICAL               EQU     0
HID_MAIN_ITEM_COLLECTION_APPLICATION            EQU     1
HID_MAIN_ITEM_COLLECTION_LOGICAL                EQU     2
HID_MAIN_ITEM_COLLECTION_REPORT                 EQU     3
HID_MAIN_ITEM_COLLECTION_NAMED_ARRAY            EQU     4
HID_MAIN_ITEM_COLLECTION_USAGE_SWITCH           EQU     5
HID_MAIN_ITEM_COLLECTION_USAGE_MODIFIER         EQU     6


;======================================== Functions =======================================;
HidD_FlushQueue PROTO :XWORD
HidD_FreePreparsedData PROTO :XPTR
HidD_GetAttributes PROTO :XWORD,:XPTR
HidD_GetConfiguration PROTO :XWORD,:XPTR,:XWORD
HidD_GetFeature PROTO :XWORD,:XPTR,:XWORD
HidD_GetHidGuid PROTO :XPTR
HidD_GetIndexedString PROTO :XWORD,:XWORD,:XPTR,:XWORD
HidD_GetInputReport PROTO :XWORD,:XPTR,:XWORD
HidD_GetManufacturerString PROTO :XWORD,:XPTR,:XWORD
HidD_GetMsGenreDescriptor PROTO :XWORD,:XPTR,:XWORD
HidD_GetNumInputBuffers PROTO :XWORD,:XPTR
HidD_GetPhysicalDescriptor PROTO :XWORD,:XPTR,:XWORD
HidD_GetPreparsedData PROTO :XWORD,:XPTR
HidD_GetProductString PROTO :XWORD,:XPTR,:XWORD
HidD_GetSerialNumberString PROTO :XWORD,:XPTR,:XWORD
HidD_Hello PROTO :XPTR,:XWORD
HidD_SetConfiguration PROTO :XWORD,:XPTR,:XWORD
HidD_SetFeature PROTO :XWORD,:XPTR,:XWORD
HidD_SetNumInputBuffers PROTO :XWORD,:XWORD
HidD_SetOutputReport PROTO :XWORD,:XPTR,:XWORD
HidP_GetButtonArray PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XWORD
HidP_GetButtonCaps PROTO :XWORD,:XPTR,:XPTR,:XPTR
HidP_GetCaps PROTO :XPTR,:XPTR
HidP_GetData PROTO :XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD
HidP_GetExtendedAttributes PROTO :XWORD,:XWORD,:XPTR,:XPTR,:XPTR
HidP_GetLinkCollectionNodes PROTO :XPTR,:XPTR,:XPTR
HidP_GetScaledUsageValue PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD
HidP_GetSpecificButtonCaps PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR
HidP_GetSpecificValueCaps PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR
HidP_GetUsageValue PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD
HidP_GetUsageValueArray PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XWORD
HidP_GetUsages PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XWORD
HidP_GetUsagesEx PROTO :XWORD,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XWORD
HidP_GetValueCaps PROTO :XWORD,:XPTR,:XPTR,:XPTR
HidP_InitializeReportForID PROTO :XWORD,:XWORD,:XPTR,:XPTR,:XWORD
HidP_MaxDataListLength PROTO :XWORD,:XPTR
HidP_MaxUsageListLength PROTO :XWORD,:XWORD,:XPTR
HidP_SetButtonArray PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XWORD
HidP_SetData PROTO :XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XWORD
HidP_SetScaledUsageValue PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XWORD
HidP_SetUsageValue PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XWORD
HidP_SetUsageValueArray PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XWORD
HidP_SetUsages PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XWORD
HidP_TranslateUsagesToI8042ScanCodes PROTO :XPTR,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR
HidP_UnsetUsages PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XWORD
HidP_UsageListDifference PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XWORD

;======================= Undocumented functions (unknown arguments) =======================;
;HidP_GetVersionInternal PROTO

ENDIF ;HID_INC
